#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

//note to self: invaluable information about hStdOutput at http://www.bolekvrany.cz/index.php?lang=en&what=articles&subsection=control_another_app

#define PROGRAM_NO_OUTPUT 0
#define PROGRAM_GAVE_OUTPUT 1
#define PROGRAM_CRASHED 2
#define PROGRAM_TIMED_OUT 3
#define timeout 1000
//note: the ROM will need to be opened with fopen/etc
#define abort(code) do { TerminateProcess(myProcess, 0); cleanup(); return code; } while(0)
#define dead() abort(PROGRAM_CRASHED)
#define cleanup() do { CloseHandle(hStdOutRead); CloseHandle(hStdOutWrite); \
											CloseHandle(myProcess); CloseHandle(processInformation.hThread); } while(0)

int main(int argc, char * argv[])
{
	SECURITY_ATTRIBUTES saAttr;
	HANDLE hStdOutRead;
	HANDLE hStdOutWrite;
	saAttr.nLength=sizeof(SECURITY_ATTRIBUTES);
	saAttr.bInheritHandle=TRUE;
	saAttr.lpSecurityDescriptor=NULL;
	CreatePipe(&hStdOutRead, &hStdOutWrite, &saAttr, 0);
	PROCESS_INFORMATION processInformation;
	STARTUPINFO startupInfo;
	memset(&processInformation, 0, sizeof(processInformation));
	memset(&startupInfo, 0, sizeof(startupInfo));
	startupInfo.cb=sizeof(startupInfo);
	startupInfo.dwFlags=STARTF_USESTDHANDLES;
	startupInfo.hStdOutput=hStdOutWrite;
	CreateProcess(argv[1], "xkas.exe thistest.asm", NULL, NULL, TRUE, NORMAL_PRIORITY_CLASS|DEBUG_PROCESS|DEBUG_ONLY_THIS_PROCESS|STARTF_USESTDHANDLES,
														NULL, NULL, &startupInfo, &processInformation);
	HANDLE myProcess=processInformation.hProcess;
//#define a(x) printf(#x"=%u\n", x)
//a(EXCEPTION_DEBUG_EVENT);
//a(CREATE_THREAD_DEBUG_EVENT);
//a(CREATE_PROCESS_DEBUG_EVENT);
//a(EXIT_THREAD_DEBUG_EVENT);
//a(EXIT_PROCESS_DEBUG_EVENT);
//a(LOAD_DLL_DEBUG_EVENT);
//a(UNLOAD_DLL_DEBUG_EVENT);
//a(OUTPUT_DEBUG_STRING_EVENT);
//a(RIP_EVENT);
//#undef a
	int numDebugEvents=0;
	DEBUG_EVENT debug;
	ZeroMemory(&debug, sizeof(DEBUG_EVENT));
	while (true)
	{
		if (!WaitForDebugEvent(&debug, timeout)) abort(PROGRAM_TIMED_OUT);
		ContinueDebugEvent(debug.dwProcessId, debug.dwThreadId, DBG_CONTINUE);
//printf("%i ", debug.dwDebugEventCode);
		if (debug.dwDebugEventCode==EXCEPTION_DEBUG_EVENT)
		{
			if (numDebugEvents++==8) dead();
		}
		if (debug.dwDebugEventCode==EXIT_PROCESS_DEBUG_EVENT) break;
		if (debug.dwDebugEventCode==OUTPUT_DEBUG_STRING_EVENT) dead();
	}
	if (WaitForSingleObject(myProcess, timeout)==WAIT_TIMEOUT) abort(PROGRAM_TIMED_OUT);
	char buffer[1024];
	DWORD d;
	bool out=false;
	while (true)
	{
		PeekNamedPipe(hStdOutRead, buffer, sizeof(buffer)-1, &d, NULL, NULL);
		if (!d) break;
		out=true;
		ReadFile(hStdOutRead, buffer, sizeof(buffer)-1, &d, NULL);
		buffer[d]=0;
		printf("%s", buffer);
	}
	cleanup();
	return out?PROGRAM_GAVE_OUTPUT:PROGRAM_NO_OUTPUT;
}
